import { ClassificationSpecificEnum } from '@pieces.app/client';

export default function langReadableToExt(readable: string) {
  return langReadableToExtMap[readable.toLowerCase()];
}

const langReadableToExtMap: { [key: string]: string } = {
  batch: ClassificationSpecificEnum.Bat,
  coffee: ClassificationSpecificEnum.Coffee,
  erlang: 'erl',
  haskell: 'hs',
  lua: 'lua',
  markdown: 'md',
  matlab: 'matlab',
  'objective-c': 'm',
  c: 'c',
  'c++': 'cpp',
  'c++ source': 'cc',
  'c++ header': 'h',
  'c++ h-header': 'hh',
  'c#': 'cs',
  css: 'css',
  go: 'go',
  html: 'html',
  htm: 'htm',
  java: 'java',
  javascript: 'js',
  typescript: 'ts',
  dart: 'dart',
  scala: 'scala',
  sql: 'sql',
  perl: 'pl',
  php: 'php',
  python: 'py',
  'python-c': 'pyc',
  powershell: 'ps1',
  r: 'r',
  bash: 'sh',
  swift: 'swift',
  ruby: 'rb',
  tex: 'tex',
  plaintextgrammar: 'text',
  rust: 'rs',
  json: 'json',
  yaml: 'yml',
  toml: 'toml',
  xml: 'xml',
  groovy: 'groovy',
  kotlin: 'kt',
  clojure: 'clj',
  lisp: 'el',
  elixir: 'ex',
  solidity: 'sol',
  systemverilog: 'sv',
  coldfusion: 'clm',
  asp: 'asp',
};
